Summary: A set of X Window System screensavers.
Name: xscreensaver
Version: 4.18
Release: 5.rhel4.14
Epoch: 1
License: BSD
Group: Amusements/Graphics
URL: http://www.jwz.org/xscreensaver/
Source: http://www.jwz.org/xscreensaver/xscreensaver-%{version}.tar.gz
Source3: xscreensaver-fortune-standin
Patch1: xscreensaver-4.18-change-defaults.patch
Patch2: xscreensaver-4.16-fixup-pam.patch
Patch3: xscreensaver-4.16-sanitize-hacks.patch
Patch4: xscreensaver-4.18-stuff-piecewise-leak.patch
Patch5: xscreensaver-4.18-prune-hack-list.patch
Patch6: xscreensaver-4.18-vroot.patch
Patch7: xscreensaver-4.18-ignore-uninstalled-hacks.patch
Patch8: xscreensaver-4.18-dont-print-stderr.patch
Patch9: xscreensaver-4.18-signal-handler-fun.patch
Patch10: xscreensaver-4.18-rd-bomb-crash.patch
Patch11: xscreensaver-4.18-cleanup-root-pixmap.patch

# CVE-2007-1859 https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=237003
Patch12: xscreensaver-4.18-check-for-null-passwd-entry.patch

#Patch20: xscreensaver-4.18-gtk-lock.patch
BuildPrereq: bc, pam-devel, XFree86-devel
BuildPrereq: gtk2-devel libglade2-devel
Requires: /etc/pam.d/system-auth, xloadimage, htmlview
Obsoletes: xscreensaver-gl
Buildroot: %{_tmppath}/xscreensaver-root
%define stand_in_path %{_prefix}/X11R6/lib/xscreensaver/fortune

%description
The xscreensaver package contains a variety of screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure.

%prep
%setup -q
%patch1 -p1 -b .change-defaults
%patch2 -p1 -b .fixup-pam
%patch3 -p1 -b .sanitize-hacks
%patch4 -p1 -b .stuff-piecewise-leak
%patch5 -p1 -b .prune-hack-list
%patch6 -p1 -b .vroot
%patch7 -p1 -b .ignore-uninstalled-hacks
%patch8 -p1 -b .dont-print-stderr
%patch9 -p1 -b .signal-handler-fun
%patch10 -p1 -b .rd-bomb-crash
%patch11 -p1 -b .cleanup-root-pixmap
%patch12 -p1 -b .check-for-null-passwd-entry
# This has some issues currently.
#%patch20 -p1 -b .gtklock
#%patch21 -p1 -b .cjkim

%build
cp /usr/share/libtool/config.{sub,guess} .
autoconf
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" ./configure \
	--prefix=%{_prefix}/X11R6 \
	--without-motif --with-pam --with-gl --with-gtk2 \
	--without-kerberos \
        --without-gnome \
	--with-fortune=%{stand_in_path}
# Change the default.  If the fortune app isn't installed at compile-time,
# xscreensaver defaults to /usr/games/fortune anyway, which screws us unless
# xscreensaver is already installed, so force it.
awk '/^#define FORTUNE_PROGRAM/ {print "#define FORTUNE_PROGRAM \"%{stand_in_path}\""; next} {print}' config.h > config.h.stand_in && cat config.h.stand_in > config.h
make

%install
rm -rf $RPM_BUILD_ROOT
export KDEDIR=%{_prefix}

make install_prefix=$RPM_BUILD_ROOT \
   KDEDIR=/usr \
   GNOME_BINDIR=%{_prefix}/bin \
   GNOME_DATADIR=%{_prefix}/share \
   datadir=/usr/share \
   install || :

desktop-file-install --vendor gnome --delete-original                   \
  --dir $RPM_BUILD_ROOT%{_datadir}/control-center-2.0/capplets          \
  --add-only-show-in GNOME                                              \
  --add-category X-Red-Hat-Base                                         \
  $RPM_BUILD_ROOT%{_datadir}/control-center-2.0/capplets/*

# Install our stand-in for fortune in the right place, taking care to
# error out if a module exists with the same name.  We do this because
# fortune is going away.  The contents of the stand-in script can be modified
# to call fortune if you still have it installed after an upgrade, or it
# can be overridden from the configuration dialogs or using X resources.
test -e $RPM_BUILD_ROOT/%{stand_in_path} && exit 1 || :
install -m 755 $RPM_SOURCE_DIR/xscreensaver-fortune-standin \
 $RPM_BUILD_ROOT/%{stand_in_path}

mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m 644 driver/xscreensaver.pam \
 $RPM_BUILD_ROOT/etc/pam.d/xscreensaver

# Doesn't appear to be needed anymore
#mkdir -p $RPM_BUILD_ROOT%{_prefix}/X11R6/share/locale
#mv $RPM_BUILD_ROOT%{_prefix}/share/locale/* \
#	$RPM_BUILD_ROOT%{_prefix}/X11R6/share/locale

%find_lang %{name}

rm -rf $RPM_BUILD_ROOT%{_datadir}/applications \
 $RPM_BUILD_ROOT%{_datadir}/control-center/capplets/screensaver-properties.desktop \

# Get rid of some config files/man pages that we don't want
rm -f $RPM_BUILD_ROOT/%{_datadir}/control-center/screensavers/{flag,fontglide,rocks,gltext,morph3d,pipes,cosmos,electricsheep,extrusion,fireflies,goban,sphereEversion,ssystem,xaos,xdaliclock,xearth,xfishtank,xmountains,xplanet,xsnow,ljlatest,xsublim,webcollage}.xml

rm -f $RPM_BUILD_ROOT/%{_prefix}/X11R6/man/man1/{flag,fontglide,rocks,gltext,morph3d,pipes,cosmos,electricsheep,extrusion,fireflies,goban,sphereEversion,ssystem,xaos,xdaliclock,xearth,xfishtank,xmountains,xplanet,xsnow,ljlatest,xsublim,webcollage}.*


%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(-,root,root)
%doc README README.debugging
%config(missingok) /etc/pam.d/xscreensaver
%attr(0755,root,root) %{_prefix}/X11R6/bin/xscreensaver
%{_bindir}/*
%{_prefix}/X11R6/bin/xscreensaver-*
%config %{_prefix}/X11R6/lib/X11/app-defaults/XScreenSaver
%{_prefix}/X11R6/man/man1/*.*
%{_prefix}/X11R6/lib/xscreensaver
%{_datadir}/control-center/screensavers
%{_datadir}/control-center/Desktop/*
%{_datadir}/control-center-2.0/capplets/*
%{_datadir}/xscreensaver
%{_datadir}/pixmaps/*

%changelog
* Wed Apr 18 2007 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.14
- check for null return value in getpwuid() call (CVE-2007-1859, 
  Resolves: #237003)

* Fri Jan 19 2007 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.13
- cleanup root pixmap when switching screenhacks (bug 196206)

* Fri Jul 21 2006 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.12
- apply backport for bug 199675 (rd-bomb crash) 
  from Bastien Nocera <bnocera@redhat.com>

* Wed Aug 10 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.11
- Launch help in terminal (bug 167968)
- Don't authenticate with app specific kerberos code.  Rely on
  PAM instead (bug 183246).

* Wed Aug 10 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.10
- Don't printf in SIGCHLD handler (bug 165601)

* Mon Jul 11 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.9
- Spell ssystem and sphereEversion right.
- Get rid of the man pages, too

* Tue Jul 8 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.8
- dont print debug spew to screensaver window

* Tue Jul 8 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.7
- Remove the xml config files in a different way that works 
  better

* Tue Jul 5 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.6
- Hard code the screen hack ignoring stuff, so that users with
  existing xscreensaver files get it, too.

* Mon Jun 27 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.5
- ignore uninstalled screenhacks, since keeping them in the
  list would just confuse the user
- consolidate the various config patches into one patch

* Mon Jun 27 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.4
- fix up config files

* Mon Jun 27 2005 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.3
- Add vroot patch from Than Ngo from FC-4 (bug 160529).
- prune more hacks (bug 158224).

* Sat Nov 20 2004 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.2
- When reverting the less important fixes I reverted the important
  one, too.

* Thu Nov 18 2004 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4.1
- revert some of the less important fixes from last commit
  so this is more suitable for breaking the freeze (only keeping 
  the "remove webcollage screensaver" [bug 139513] fix)

* Thu Nov 18 2004 Ray Strode <rstrode@redhat.com> 4.18-5.rhel4
- remove webcollage screensaver like what was done for RHEL3
  (bug 139513).
- give vidwhacker screensaver working defaults (bug 64518)
- Get rid of old crufty %{_datadir}/control-center/ tree
  (bug 114692)

* Wed Nov 3 2004 Ray Strode <rstrode@redhat.com> 1:4.18-5
- Don't allow screensavers access to desktop images by default (bug #126809)
- Lock screen by default (bug #126809)

* Tue Oct 19 2004  <krh@redhat.com> 4.18-4
- Add xscreensaver-4.18-stuff-piecewise-leak.patch to stop piecewise
  from leaking (#135164).

* Wed Sep 1 2004 Ray Strode <rstrode@redhat.com> 4.18-3
- remove superfluous line in the spec file

* Wed Sep 1 2004 Ray Strode <rstrode@redhat.com> 4.18-2
- blank the screen by default

* Tue Aug 24 2004 Ray Strode <rstrode@redhat.com> 4.18-1
- update to 4.18 (fixes bug 87745).

* Sat Aug 14 2004 Ray Strode <rstrode@redhat.com> 4.16-4
- change titles of questionably named bar codes
  (fixes bug 129929).

* Fri Aug 6 2004 Ray Strode <rstrode@redhat.com> 4.16-3
- change titles of questionably named shape formations
  (fixes bug 129335).

* Wed Jun 23 2004 Ray Strode <rstrode@redhat.com> 4.16-2
- use htmlview for browsing help.

* Mon Jun 21 2004 Ray Strode <rstrode@redhat.com> 4.16-1
- update to 4.16.  Use desktop-file-install for desktop file.

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed May  5 2004 Bill Nottingham <notting@redhat.com> 4.14-5
- config tweaks

* Wed Mar 31 2004 Karsten Hopp <karsten@redhat.de> 4.14-4 
- fix fortune stand-in (#115369)

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon Oct 27 2003 Bill Nottingham <notting@redhat,com> 1:4.14-1
- update to 4.14

* Tue Oct  7 2003 Bill Nottingham <notting@redhat.com> 1:4.13-1
- take out flag-with-logo, don't require redhat-logos (#106046)
- update to 4.13

* Wed Aug 27 2003 Bill Nottingham <notting@redhat.com> 1:4.12-1
- update to 4.12 (fixes #101920)
- re-add BSOD to the random list

* Tue Jun 24 2003 Bill Nottingham <notting@redhat.com> 1:4.11-1
- update to 4.11

* Fri Jun 13 2003 Bill Nottingham <notting@redhat.com> 1:4.10-3
- fix some 64-bit arches (#97359)

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed May 28 2003 Bill Nottingham <notting@redhat.com> 1:4.10-1
- update to 4.10

* Thu Mar 20 2003 Bill Nottingham <notting@redhat.com> 1:4.09-1
- update to 4.09, now with bouncing cows

* Mon Feb 10 2003 Bill Nottingham <notting@redhat.com> 1:4.07-2
- oops, xloadimage *is* needed (#83676)

* Thu Feb  6 2003 Bill Nottingham <notting@redhat.com> 1:4.07-1
- update to 4.07, fixes #76276, #75574

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Fri Nov 29 2002 Tim Powers <timp@redhat.com> 1:4.06-4
- call autoconf instead of autoconf-2.53

* Mon Nov 11 2002 Bill Nottingham <notting@redhat.com> 4.06-3
- put glade tweaks back in
- switch pam package to not specify directories, to work on multilib
  arches

* Fri Nov  8 2002 Nalin Dahyabhai <nalin@redhat.com> 4.06-1
- add a BuildPrereq on bc, which configure requires
- replace use of fortune with an innocuous-and-editable stand-in script in
  %{stand_in_path}
- define FORTUNE_PROGRAM at compile-time to force apps to use what's specified
  even if it doesn't happen to be installed at compile-time

* Sun Sep  2 2002 Bill Nottingham <notting@redhat.com> 4.05-6
- fix typo (#73246)

* Wed Aug 28 2002 Bill Nottingham <notting@redhat.com> 4.05-5
- revert to non-gtk unlock dialog
- fix translations

* Mon Aug 12 2002 Bill Nottingham <notting@redhat.com> 4.05-4
- twiddle titlebar (#67844)
- fix extraneous text (#70975)
- tweak desktop entry (#69502)

* Fri Aug 9 2002 Yu Shao <yshao@redhat.com> 4.05-3
- use GTK_IM_MODULE=gtk-im-context-simple in lock widget
- to avoid CJK IM weirdness (#70655, #68216)
- xscreensaver-rh-imcjk.patch

* Wed Jul 17 2002 Elliot Lee <sopwith@redhat.com> 4.05-2
- Add fortune-mod to buildprereq to make beehive happy
- Fix find_lang usage - install translations properly by specifying datadir

* Tue Jun 11 2002 Bill Nottingham <notting@redhat.com> 4.05-1
- update to 4.05
- use gtk2 lock widget (<jacob@ximian.com>)
- some Red Hat-ifications
- fix critical (#63916)

* Mon Jun 10 2002 Bill Nottingham <notting@redhat.com> 4.04-2
- remove no longer needed xloadimage dependency

* Mon Jun  3 2002 Bill Nottingham <notting@redhat.com> 4.04-1
- update to 4.04, gtk2 property dialog is now mainline

* Thu May 16 2002 Bill Nottingham <notting@redhat.com> 4.03-1
- update to 4.03
- use gtk2 properties dialog

* Thu Mar 14 2002 Bill Nottingham <notting@redhat.com> 4.01-2
- don't show screensavers that aren't available

* Sun Feb 24 2002 Bill Nottingham <notting@redhat.com>
- update to 4.01

* Mon Feb 11 2002 Bill Nottingham <notting@redhat.com>
- update to 4.00

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Aug 23 2001 Bill Nottingham <notting@redhat.com>
- fix segfault on ia64 (#52336)

* Thu Aug  9 2001 Bill Nottingham <notting@redhat.com>
- never mind, back to 3.33 (wheeee)
- hack window-id back in for the time being
- disable memlimit so GL works

* Mon Jul 23 2001 Bill Nottingham <notting@redhat.com>
- oops, back to 3.32 for now
- remove optflags override (oops)
- add pam-devel buildprereq

* Mon Jul 16 2001 Bill Nottingham <notting@redhat.com>
- update to 3.33, fix broken last build
- fix build weirdness on some package sets (#48905)
- don't document non-existent options for forest (#49139)

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Tue May 22 2001 Havoc Pennington <hp@redhat.com>
- putting in tree for David 

* Tue May 22 2001 David Sainty <dsainty@redhat.com>
- added DPMS options to command line help

* Sun Apr 22 2001 Bill Nottingham <notting@redhat.com>
- update to 3.32
- add patch to specify DPMS settings on the command line

* Wed Apr 11 2001 Bill Nottingham <notting@redhat.com>
- update to 3.31

* Wed Apr  4 2001 Bill Nottingham <notting@redhat.com>
- fix extrusion exclusion (#34742)

* Tue Apr  3 2001 Bill Nottingham <notting@redhat.com>
- disable GL screensavers by default (bleah)

* Mon Feb 19 2001 Bill Nottingham <notting@redhat.com>
- update to 3.29 (#27437)

* Tue Jan 23 2001 Bill Nottingham <notting@redhat.com>
- update to 3.27

* Fri Dec 01 2000 Bill Nottingham <notting@redhat.com>
- rebuild because of broken fileutils

* Fri Nov 10 2000 Bill Nottingham <notting@redhat.com>
- 3.26

* Fri Aug 11 2000 Jonathan Blandford <jrb@redhat.com>
- Up Epoch and release

* Wed Jul 26 2000 Bill Nottingham <notting@redhat.com>
- hey, vidmode works again

* Fri Jul 21 2000 Bill Nottingham <notting@redhat.com>
- update to 3.25

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sat Jun 17 2000 Bill Nottingham <notting@redhat.com>
- xscreensaver.kss is not a %%config file.

* Sun Jun 11 2000 Bill Nottingham <notting@redhat.com>
- tweak kss module (#11872)

* Thu Jun  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- modify PAM configuration to use system-auth

* Thu May 18 2000 Preston Brown <pbrown@redhat.com>
- added Red Hat screensaver (waving flag has logo now).

* Fri May  5 2000 Bill Nottingham <notting@redhat.com>
- tweaks for ia64

* Mon Apr 10 2000 Bill Nottingham <notting@redhat.com>
- turn off xf86vidmode ext, so that binaries built against XFree86 4.0
  work on 3.x servers

* Wed Apr  5 2000 Bill Nottingham <notting@redhat.com>
- turn off gnome support for now

* Mon Apr  3 2000 Bill Nottingham <notting@redhat.com>
- update to 3.24

* Wed Feb 09 2000 Preston Brown <pbrown@redhat.com>
- wmconfig entry gone.

* Mon Jan 31 2000 Bill Nottingham <notting@redhat.com>
- update to 3.23

* Fri Jan 14 2000 Bill Nottingham <notting@redhat.com>
- rebuild to fix GL depdencies

* Tue Dec 14 1999 Bill Nottingham <notting@redhat.com>
- everyone in GL
- single package again

* Fri Dec 10 1999 Bill Nottingham <notting@redhat.com>
- update to 3.22
- turn off xf86vmode on alpha

* Tue Dec  7 1999 Bill Nottingham <notting@redhat.com>
- mmm... hardware accelerated GL on i386. :) :)

* Mon Nov 22 1999 Bill Nottingham <notting@redhat.com>
- 3.21
- use shm on alpha, let's see what breaks

* Tue Nov 16 1999 Bill Nottingham <notting@redhat.com>
- update to 3.20

* Wed Nov  3 1999 Bill Nottingham <notting@redhat.com>
- update to 3.19

* Thu Oct 14 1999 Bill Nottingham <notting@redhat.com>
- update to 3.18

* Sat Sep 25 1999 Bill Nottingham <notting@redhat.com>
- add a '-oneshot' single time lock option.

* Mon Sep 20 1999 Bill Nottingham <notting@redhat.com>
- take webcollage out of random list (for people who pay for bandwidth)

* Fri Sep 10 1999 Bill Nottingham <notting@redhat.com>
- patch webcollage to use xloadimage
- in the random list, run petri with -size 2 to save memory
- extend RPM silliness to man pages, too.

* Mon Jul 19 1999 Bill Nottingham <notting@redhat.com>
- update to 3.17
- add a little RPM silliness to package GL stuff if it's built

* Thu Jun 24 1999 Bill Nottingham <notting@redhat.com>
- update to 3.16

* Mon May 10 1999 Bill Nottingham <notting@redhat.com>
- update to 3.12

* Tue May  4 1999 Bill Nottingham <notting@redhat.com>
- remove security problem introduced earlier

* Wed Apr 28 1999 Bill Nottingham <notting@redhat.com>
- update to 3.10

* Thu Apr 15 1999 Bill Nottingham <notting@redhat.com>
- kill setuid the Right Way(tm)

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- fix xflame on alpha

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- upgrade to 3.09, fixes vmware interaction problems.

* Mon Apr  5 1999 Bill Nottingham <notting@redhat.com>
- remove setuid bit. Really. I mean it.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Fri Mar 19 1999 Bill Nottingham <notting@redhat.com>
- kill setuid, since pam works OK

* Tue Mar 16 1999 Bill Nottingham <notting@redhat.com>
- update to 3.08

* Wed Feb 24 1999 Bill Nottingham <notting@redhat.com>
- wmconfig returns, and no one is safe...

* Tue Feb 23 1999 Bill Nottingham <notting@redhat.com>
- remove bsod from random list because it's confusing people???? *sigh*

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize to get it to compile cleanely on the arm

* Tue Jan  5 1999 Bill Nottingham <notting@redhat.com>
- update to 3.07

* Mon Nov 23 1998 Bill Nottingham <notting@redhat.com>
- update to 3.06

* Tue Nov 17 1998 Bill Nottingham <notting@redhat.com>
- update to 3.04

* Thu Nov 12 1998 Bill Nottingham <notting@redhat.com>
- update to 3.02
- PAMify

* Tue Oct 13 1998 Cristian Gafton <gafton@redhat.com>
- take out Noseguy module b/c of possible TMv
- install modules in /usr/X11R6/lib/xscreensaver
- don't compile support for xshm on the alpha
- properly buildrooted
- updated to version 2.34

* Fri Aug  7 1998 Bill Nottingham <notting@redhat.com>
- update to 2.27

* Wed Jun 10 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Mon Jun 08 1998 Erik Troan <ewt@redhat.com>
- added fix for argv0 buffer overflow

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat Apr 11 1998 Donnie Barnes <djb@redhat.com>
- updated from 2.10 to 2.16
- added buildroot

* Wed Oct 25 1997 Marc Ewing <marc@redhat.com>
- wmconfig

* Thu Oct 23 1997 Marc Ewing <marc@redhat.com>
- new version, configure

* Fri Aug 22 1997 Erik Troan <ewt@redhat.com>
- built against glibc

